pSpeed = GetFloatParam("speed", 2.0)
flickerSpeed = GetFloatParam("flickerSpeed", 2.0)
power = GetFloatParam("power", 0)

function init()
	motor = FindJoint("motor")
	wLight = FindShape("warninglight")
	mLight = FindShape("machinelight")
	button = FindShape("button")
	body = FindBody("elevatorbody")
	bt = GetBodyTransform(body)
	limitMin, limitMax = GetJointLimits(motor)


	clickUp = LoadSound("clickup")
	clickDown = LoadSound("clickdown")

	motorSound = LoadLoop("vehicle/hydraulic-loop.ogg")
	stuckSound = LoadLoop("MOD/elevator/hydraulic-loop-stuck.ogg")
	stopSound = LoadSound("MOD/elevator/elevator_stop.ogg")
	startSound = LoadSound("MOD/elevator/elevator_start.ogg")
	sparkSound = LoadSound("MOD/elevator/spark-0.ogg")

	mLightTimer = 0.0
	mLightEmissive = 0
	timer = 0.0
	buttonUp = false
	isMoving = false
	lastMotorPos = GetJointMovement(motor)

end

function machinelightflicker(delta)
	if timer - mLightTimer > 0 then
		mLightEmissiveNew = math.random(1,10)/10.0
		if mLightEmissiveNew > mLightEmissive then
			mLightEmissive = mLightEmissiveNew
			PlaySound(sparkSound, bt.pos)
		end
		mLightTimer = timer + (math.random(1,flickerSpeed)/10);
		--print("mLightEmissive: " .. mLightEmissive)
	end

	mLightEmissive = mLightEmissive - delta * 4.0

	if mLightEmissive <= 0 then
		mLightEmissive = 0
	end

	SetShapeEmissiveScale(mLight, mLightEmissive)
end

function tick(dt)
	timer = timer + dt
	bt = GetBodyTransform(body)

	if isMoving then
		machinelightflicker(dt)
		SetShapeEmissiveScale(wLight, 1)
	else
		SetShapeEmissiveScale(mLight, 0)
		SetShapeEmissiveScale(wLight, 0)
	end

	if GetPlayerInteractShape() == button and InputPressed("interact") then
		local t = GetShapeLocalTransform(button)
		PlaySound(startSound, bt.pos)
		if buttonUp then
			PlaySound(clickDown, bt.pos)
			t.pos[1] = t.pos[1] + 0.1
			SetShapeLocalTransform(button, t)

			lastMotorPos = GetJointMovement(motor) + 0.1
			buttonUp = false
			--print("buttonUp: false")
		else
			PlaySound(clickUp,bt.pos)
			t.pos[1] = t.pos[1] - 0.1
			SetShapeLocalTransform(button, t)

			lastMotorPos = GetJointMovement(motor) - 0.1
			buttonUp = true
			--print("buttonUp: true")
		end
	end

	eps = 0.01
	if buttonUp then -- Moving on up!!
		if GetJointMovement(motor) <= lastMotorPos and isMoving then -- Are we stuck?
			PlayLoop(stuckSound, bt.pos)
		else
			lastMotorPos = GetJointMovement(motor)
			if GetJointMovement(motor) < limitMax-eps then
				SetJointMotor(motor, -pSpeed, power)
				PlayLoop(motorSound, bt.pos)
				isMoving = true
			else
				if isMoving then
					PlaySound(stopSound)
				end
				isMoving = false
			end
		end
	else -- Getting back down...
		if GetJointMovement(motor) >= lastMotorPos and isMoving then -- Are we stuck?
			PlayLoop(stuckSound, bt.pos)
		else
			lastMotorPos = GetJointMovement(motor)
			if GetJointMovement(motor) > limitMin+eps then
			SetJointMotor(motor, pSpeed, power)
			PlayLoop(motorSound, bt.pos)
			isMoving = true
			else
				if isMoving then
					PlaySound(stopSound, bt.pos)
				end
				isMoving = false
			end
		end
	end
end
