#include "script/common.lua"

function init()
	bomb = FindBody("largebomb")
	bombshape = FindShape("largebomb")
	beep = LoadSound("MOD/scripts/beep.ogg")
	bombInPlace = false
	explosionSound = LoadSound("explosion/l0.ogg")

	lights = {}
	for i = 1, 5 do
	    lights[i] = FindShapes("light" .. i)
	    for j = 1,#lights[i] do
	    	SetShapeEmissiveScale(lights[i][j], 0)
	    end
	end

	started = false
	timer = 0
	intCounter = 0
	fracCounter = 0
	counter = 10
	exploded = false
	fireTime = 0
end

function rnd(mi, ma)
	return math.random(0, 1000)/1000*(ma-mi)+mi
end

function tick(dt)
	if exploded then
		--Burn for a while
		fireTime = fireTime + dt
		local pos
		if fireTime < 2 and rnd(0.0, 2.0) > fireTime then
			pos = VecAdd(firePos, Vec(rnd(-2,2), 0.0, rnd(-2,2)))
			SpawnParticle("fire", pos, Vec(rnd(-2, 2), rnd(2, 4), rnd(-2, 2)), 2, 3)
			pos = VecAdd(firePos, Vec(rnd(-2,2), 0.0, rnd(-2,2)))
			SpawnParticle("darksmoke", pos, Vec(rnd(-2, 2), rnd(2, 4), rnd(-2,2)), 4, 6)
		end
		if fireTime < 5 and rnd(0.0, 5.0) > fireTime then
			pos = VecAdd(firePos, Vec(rnd(-0.5,0.5), 0.0, rnd(-0.5,0.5)))
			SpawnParticle("fire", pos, Vec(rnd(-0.5, 0.5), rnd(2, 4), rnd(-0.5, 0.5)), 1.0, 0.3)
			pos = VecAdd(firePos, Vec(rnd(-0.5,0.5), 0.0, rnd(-0.5,0.5)))
			SpawnParticle("darksmoke", pos, Vec(0, rnd(3, 5), 0), 1.0, 1)
		end
		return
	end

	timer = timer - dt

	--Check if bomb is in required area
	--local b = IsBodyInTrigger(trigger,bomb)
	b = true
	if not bombInPlace and b then
		--SetString("hud.notification", "Bomb active")
		SetTag(bomb, "interact", "Detonate")
	end
	bombInPlace = b

	-- Countdown and it's lights
	if started then 
		intCounter = math.ceil(timer/2)
		intCounter = math.clamp(intCounter,0,6)
		fracCounter = (math.floor(((timer/2) % 1) * 2)/2)+0.5

		if (intCounter - 1 + fracCounter ~= counter) and counter > 0 then
			PlaySound(beep, GetBodyTransform(bomb).pos, 0.3)
			counter = intCounter - 1 + fracCounter
			if counter == 0 then
				PlaySound(explosionSound)
				RemoveTag(bomb, "unbreakable")
				firePos = GetBodyTransform(bomb).pos
				Explosion(firePos, 4, true)
				exploded = true
			end
			--DebugPrint("int: " .. intCounter .. " | \tfrac: " .. fracCounter .. " | \tcnt: " .. counter)
		end

		if intCounter > 0 then
			for j = 1,#lights[intCounter] do
		    	SetShapeEmissiveScale(lights[intCounter][j], fracCounter)
		    end
		end
		
	    if intCounter < 5 then
	    	for j = 1,#lights[intCounter+1] do
				SetShapeEmissiveScale(lights[intCounter+1][j], 0)
			end
		end

	end

	if GetPlayerInteractBody() == bomb and InputPressed("interact") then
		for i = 1, 5 do
			for j = 1,#lights[i] do
				SetShapeEmissiveScale(lights[i][j], 1)
			end
		end
		started = true
		timer = 10
		counter = 10
	end
end

