function clamp(value, mi, ma)
	if value < mi then value = mi end
	if value > ma then value = ma end
	return value
end

function init()
	leak_size = 0
	vehicle = FindVehicle()
	local vehicle_tr = GetVehicleTransform(vehicle)
	local oilpan_loc = FindLocation("oilpan")
	if oilpan_loc == 0 then
		DebugPrint("[oil_leak.lua] Oilpan location not found.")
	end
	local oilpan_tr = GetLocationTransform(oilpan_loc)
	oilpan_local_pos = TransformToLocalPoint(vehicle_tr, oilpan_tr.pos)
end

function GetVehicleFwdSpeed(vehicle)
	local vehicle_tr = GetVehicleTransform(vehicle)
	local main_body = GetVehicleBody(vehicle)
	local velocity = TransformToLocalVec(vehicle_tr, GetBodyVelocity(main_body))
	return -velocity[3] * 3.6
end

function PaintRejectVehicle(vehicle)
end

function tick(dt)
	if GetPlayerVehicle() == vehicle then
		local vehicle_tr = GetVehicleTransform(vehicle)
		local oilpan_pos = TransformToParentPoint(vehicle_tr, oilpan_local_pos)
		local vehicle_dwn = TransformToParentVec(vehicle_tr, Vec(0, -1, 0))
		QueryRejectVehicle(vehicle)
		local hit, dist = QueryRaycast(oilpan_pos, vehicle_dwn, 1)
		if hit then
			local hit_pos = VecAdd(oilpan_pos, VecScale(vehicle_dwn, dist))
			local speed = GetVehicleFwdSpeed(vehicle)
			if speed > -0.1 and speed < 0.1 then
				leak_size = leak_size + dt / 5
				leak_size = clamp(leak_size, 0, 1)
				PaintRejectVehicle(vehicle)
				Paint(hit_pos, leak_size, "explosion", 0.9)
			else
				leak_size = 0
				Paint(hit_pos, 0.15, "explosion", 0.1)
			end
		end
	end
end
