function sign(x)
	return x > 0 and 1 or (x < 0 and -1 or 0)
end

function clamp(value, mi, ma)
	if value < mi then value = mi end
	if value > ma then value = ma end
	return value
end

function init()
	sensors = {
		{
			pos = Vec(-11.0, 5.0, 25.5),
			dir = Vec(-0.71, 0, 0.71),
			reach = 2.5
		},
		{
			pos = Vec(-7.5, 5.0, 28.0),
			dir = Vec(0, 0, 1),
			reach = 5
		},
		{
			pos = Vec(4.5, 5.0, 28.0),
			dir = Vec(0, 0, 1),
			reach = 5
		},
		{
			pos = Vec(8.0, 5.0, 25.5),
			dir = Vec(0.71, 0, 0.71),
			reach = 2.5
		}
	}
	angle = 0
	is_equipped = FindVehicle()
	warning_snd = LoadLoop("warning-beep.ogg")
end

function IsVehicleInReverse(vehicle)
	local reverse_lights = FindLights("reverse")
	local active = false
	for i = 1, #reverse_lights do
		active = active or IsLightActive(reverse_lights[i])
	end
	return active
end

function tick(dt)
	local vehicle = GetPlayerVehicle()
    if vehicle ~= 0 and vehicle == is_equipped and IsVehicleInReverse(vehicle) then
		local vehicle_tr = GetVehicleTransform(vehicle)
		for i = 1, #sensors do
			local sensor = sensors[i]
			local sensor_pos = TransformToParentPoint(vehicle_tr, VecScale(sensor.pos, 0.1))

			if InputDown("d") then
				angle = angle + dt * 15
			elseif InputDown("a") then
				angle = angle - dt * 15
			else
				angle = angle - sign(angle) * dt * 15
			end
			angle = clamp(angle, -20, 20)
			local direction = QuatRotateVec(QuatEuler(0, angle, 0), sensor.dir)
			local sensor_dir = TransformToParentVec(vehicle_tr, direction)

			QueryRejectVehicle(vehicle)
			local hit, dist = QueryRaycast(sensor_pos, sensor_dir, sensor.reach, 0, false)

			if hit then
				local hitPoint = VecAdd(sensor_pos, VecScale(sensor_dir, dist))
				DebugCross(sensor_pos, 1, 0, 0)
				DrawLine(sensor_pos, hitPoint, 1, 0, 0, 0.2)
				PointLight(hitPoint, 1, 0.1, 0.1, 0.1 * math.random() + 0.2)
				PlayLoop(warning_snd, sensor_pos, sensor.reach - dist + 0.1)
			else
				local hitPoint = VecAdd(sensor_pos, VecScale(sensor_dir, sensor.reach))
				DrawLine(sensor_pos, hitPoint, 0, 1, 0, 0.2)
			end
		end
	end
end
