function clamp(value, mi, ma)
	if value < mi then value = mi end
	if value > ma then value = ma end
	return value
end

function sign(x)
	return x > 0 and 1 or (x < 0 and -1 or 0)
end

function init()
	ScorpionKing = FindVehicle("ponsse")

	steer = FindJoints("steer")
	armJoint = FindJoints("arm1")
	center = FindJoint("center")
	movement = 0
	armAngle = 0
end

function tick(dt)
	if GetPlayerVehicle() ~= ScorpionKing then
		return
	end

	local direction = (InputDown("a") and 10 * dt or 0) - (InputDown("d") and 10 * dt or 0)
	for i = 1, #steer do
		local min, max = GetJointLimits(steer[i])
		if direction == 0 then
			movement = movement - sign(movement) * 2 * dt
		else
			movement = movement + direction
		end
		movement = clamp(movement, min, max)
		--DebugWatch("steer["..i.."]", math.floor(movement))
		SetJointMotorTarget(steer[i], movement)
	end

	local armDir = (InputDown("lmb") and 0.25 or 0) - (InputDown("rmb") and 0.25 or 0)
	for i = 1, #armJoint do
		local min, max = GetJointLimits(armJoint[i])
		armAngle = armAngle + armDir
		armAngle = clamp(armAngle, min, max)
		SetJointMotorTarget(armJoint[i], armAngle, 0.5)
	end

	SetJointMotor(center, (InputDown("r") and 0.5 or 0) - (InputDown("f") and 0.5 or 0))
end
