function init()
	vehicle = FindVehicle()
	blinkShape = FindShape("blink")
	detonatorShape = FindShape("detonator")
	frame = 0
end

function update(dt)
	frame = frame + 1

	if frame % 30 > 15 then
		SetShapeEmissiveScale(blinkShape, 1)
	else
		SetShapeEmissiveScale(blinkShape, 0)
	end
end

function tick(dt)
	local vt = GetVehicleTransform(vehicle)
	local mi, ma = GetShapeBounds(detonatorShape)
	local origin = VecLerp(mi, ma, 0.5)
	local dir = TransformToParentVec(vt, Vec(0, 0, -1))
	QueryRejectShape(detonatorShape)
	QueryRequire("physical large")
	local LINE_DIST = 10
	local hit, dist = QueryRaycast(origin, dir, LINE_DIST)
	if not hit then dist = LINE_DIST end
	local current = math.mod(GetTime(), 1.0) - 0.5
	for i = 1, LINE_DIST do
		local p0 = VecAdd(origin, VecScale(dir, current))
		local d = math.min(current + 0.5, dist)
		local p1 = VecAdd(origin, VecScale(dir, d))
		DrawLine(p0, p1, 1, 1, 1, 0.5 * (1.0-(i/LINE_DIST)))
		current = current + 1.0
		if current > dist then
			break
		end
	end
end
