function clamp(value, mi, ma)
	if value < mi then value = mi end
	if value > ma then value = ma end
	return value
end

function init()
	spawned = {}
	vehicle = FindVehicle()
	arm_body = FindBody("arm")
	hook_body = FindBody("hook")

	local arm_tr = GetBodyTransform(arm_body)
	local hook_tr = GetBodyTransform(hook_body)
	local rope_start = GetLocationTransform(FindLocation("from")).pos
	local rope_end = GetLocationTransform(FindLocation("to")).pos

	rope_start_local_pos = TransformToLocalPoint(arm_tr, rope_start)
	rope_end_local_pos = TransformToLocalPoint(hook_tr, rope_end)
	rope_length = VecLength(VecSub(rope_start, rope_end))

	SetWinchLength(rope_length)
end

function VecToString(vec)
	return "'" .. vec[1] .. " " .. vec[2] .. " " .. vec[3] .. "'"
end

function SetWinchLength(expected_length)
	local arm_tr = GetBodyTransform(arm_body)
	local hook_tr = GetBodyTransform(hook_body)
	local rope_start = TransformToParentPoint(arm_tr, rope_start_local_pos)
	local rope_end = TransformToParentPoint(hook_tr, rope_end_local_pos)

	local current_length = VecLength(VecSub(rope_start, rope_end))
	local slack = expected_length - current_length

	for _, e in pairs(spawned) do
		Delete(e)
	end

	spawned = Spawn("<rope slack='" .. slack .. "' strength='100'>\n\t<location pos=" .. VecToString(rope_start) .. "/>\n\t<location pos=" .. VecToString(rope_end) .. "/>\n</rope>", Transform(), true, true)
end

function update(dt)
	if GetPlayerVehicle() == vehicle then
		local current_length = rope_length + 4 * dt * ((InputDown("rmb") and 1 or 0) - (InputDown("lmb") and 1 or 0))
		current_length = clamp(current_length, 1, 5)
		if current_length ~= rope_length then
			rope_length = current_length
			SetWinchLength(rope_length)
		end
	end
end
